//ServConn.c

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <pthread.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <stdlib.h>
#include <netinet/in.h>
#include <sys/time.h>
#include "types.h"
#include "ServConn.h"
#include "main.h"
#include "config.h"

CSERV cserver;

int			ipport;
int			listener;
struct  sockaddr_in     addr;
pthread_mutex_t         ServerMutex;
pthread_t               hListenProcess;
int			ServerWork;

//старт сервера соединений
int server_start(int ipp)
{
	listener = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
        if(listener < 0)
                return 1;
        addr.sin_family = AF_INET;
        addr.sin_port = htons(ipp);
        addr.sin_addr.s_addr = htonl(INADDR_ANY);
        memset(&addr.sin_zero, 0, 8);
        if(bind(listener, (struct sockaddr *)&addr, sizeof(addr)) < 0)
                return 2;
        if(listen(listener, _max_sock) < 0)
                return 3;
        //mutex create
        if(!(pthread_mutex_init(&ServerMutex,NULL) == 0))
                return 4;
        //starting listen
        cserver.work = 1;
        pthread_create(&hListenProcess,NULL,(void*) server_listen,NULL);
        sleep(1);       //wait one secoond
        //
        return 0;
}

void server_listen(void)
{
	int err;
        fd_set fdss;
        struct timeval tvs;
        int count;
        int csock;
	//pthread_attr_t tattr;
//	int size	= 0x4000;
//	stacksize = 0x4000;
//	void *stackbase;
	

	pthread_mutex_lock(&ServerMutex);
        //инициализация данных
        memset(&cserver.midcl[0], 0, _max_sock);
        cserver.cntclient 		= 0;
	cserver.setcntlive		= _time_life;
	//
	//pthread_attr_init(&tattr);
	//pthread_attr_setdetachstate(&tattr, PTHREAD_CREATE_DETACHED);

	//stacksize = (PTHREAD_STACK_MIN + 0x4000);
	//pthread_attr_setstacksize(tattr, stacksize);
	// 
	//основной цикл прослушивания
        while(cserver.work)
        {
mt1:            tvs.tv_sec = 0;
                tvs.tv_usec = _LSOCKET_TIMEOUT_;
                FD_ZERO(&fdss);
                FD_SET(listener,&fdss);
                //
                err = select(listener + 1,&fdss,&fdss,NULL,&tvs);
                //err = select(listener + 1,&fdss,NULL,&fdss,&tvs);
                if(err <= 0)
                {
			pthread_mutex_unlock(&ServerMutex);
                        usleep(_listen_sleep);
			pthread_mutex_lock(&ServerMutex);
                        goto mt1;
                }
                csock = accept(listener,NULL,NULL);
                if((cserver.csock > 0) && (csock == cserver.csock))
                {
			pthread_mutex_unlock(&ServerMutex);
                        usleep(_listen_sleep);
			pthread_mutex_lock(&ServerMutex);
                        goto mt1;
                }
		//создание потока клиента
                printf("-----CLIENT-----\r\n");
                printf("-- sock. %i --\r\n", csock);
                count = 0;
                while(count < _max_sock)
                {
                        if(cserver.midcl[count] == 0)
                        {
				#if(_dbg > 0)
					printf("ServCoon clien %i connecting...\n",count);
				#endif
                                cserver.csock	 		= csock;
                                cserver.idclient 		= count;
				cserver.midcl[count]		= 0xFF;
				//				
				pthread_attr_init(&cserver.tattr[count]);
				pthread_attr_setdetachstate(&cserver.tattr[count], PTHREAD_CREATE_DETACHED);
				//thread_attr_setscope(&cserver.tattr[count], PTHREAD_SCOPE_SYSTEM);
				//
                                //pthread_create(&cserver.pth[count],NULL,(void*) server_con, &cserver);
				pthread_create(&cserver.pth[count], &cserver.tattr[count],(void*) server_con, &cserver);
				//
                                cserver.cntclient++;
				break;
				//goto mt1;
                        }
                        count++;
                }
                //
                pthread_mutex_unlock(&ServerMutex);
                usleep(_listen_sleep);
		pthread_mutex_lock(&ServerMutex);
        }
	pthread_exit(0); 
}



inline int ReadSocket(int nSocket, BYTE *pBuffer)
{
        //int     res                     = 1;
        int     	iRC                     = 0;
        int     	iReceiveStatus          = 0;
        int     	iStillToReceive         = 2; //начальный размер получения минимальных данных
        int     	iCount 	= 0;
	int		sz	= 0;
        struct timeval 	ReceiveTimeout;
        fd_set 		fds;
	U8		flag			= 0;
	
	//fcntl(nSocket, F_SETFL, O_NONBLOCK);
        //fds = calloc(1, sizeof(fd_set));// fds;
        //int size = 0;
        while(iStillToReceive > 0)
        {
                //установка величины таймаута
                FD_ZERO(&fds);
                FD_SET(nSocket, &fds);
                ReceiveTimeout.tv_sec  = 0;
                ReceiveTimeout.tv_usec = _SOCKET_TIMEOUT_;
                iRC = select(nSocket + 1, &fds, NULL, NULL, &ReceiveTimeout);
                //выход по таймауту
                if(!iRC)
			return -1;
		//произошла какая то ошибка
                if(iRC < 0)
                        return -2;
		//ошибка указания размера данных
                if(iStillToReceive <= 0)
                        return -3;
                //прием нескольких байт
		#if(_tcp_recv_deb == 1)
			printf("----read sock (recv) ----\r\n");
        	#endif
		iReceiveStatus = recv(nSocket, (char*)(pBuffer), iStillToReceive, 0);
                if(iReceiveStatus >  0)
                {
			pBuffer += iReceiveStatus;
                        iStillToReceive -= iReceiveStatus;
                        iCount += iReceiveStatus;
			if((iCount >= 2) && (flag == 0))
			{
				sz		= (*(U16*)(pBuffer - iCount));
				iStillToReceive = sz - iCount;
				#if(_tcp_recv_deb == 1)
					printf("---recv size: set %i, count %i, still %i\r\n", (*(U16*)(pBuffer - iCount)), iCount, iStillToReceive);
				#endif
				flag = 0xFF;
			}
                }
		else if(iReceiveStatus == 0)
			return -1;
		else
			return -2;
		#if(_tcp_recv_deb == 1)
			printf("==iStillToReceive:%i iCount:%i==\r\n", iStillToReceive, iCount);
		#endif
        }
        //дополнительная проверка размера
	if(sz != iCount)
		return -3;
        return iCount;
}



inline int WriteSocket(int nSocket, BYTE *pBuffer, U16 iMessageLength)
{
 	int 		iCount		= 0;
        int 		iSC 		= 0;
        int 		iSendStatus 	= 0;
        struct timeval 	SendTimeout;
        fd_set 		fds;
	//fcntl(nSocket, F_SETFL, O_NONBLOCK);
        while(iMessageLength > 0)
        {
		//установка величины таймаута
        	SendTimeout.tv_sec  = 0;
        	SendTimeout.tv_usec = _SOCKET_TIMEOUT_;
        	FD_ZERO(&fds);
        	FD_SET(nSocket, &fds);
                iSC = select(nSocket + 1, NULL, &fds, NULL, &SendTimeout);
                if(!iSC)
                        return -1; //таймаут
                if(iSC < 0)
                        return -2; //ошибка
		//отправить несколько байт
		#if(_tcp_send_deb == 1)
			printf("----write sock (send) ----\r\n");
                #endif
		iSendStatus = send(nSocket, (char*)(pBuffer), iMessageLength, 0);
                if(iSendStatus > 0)
                {
                        //обновить буфер и счетчик
                        iMessageLength -= iSendStatus;
                        pBuffer += iSendStatus;
                        iCount += iSendStatus;
                }
		else if(iSendStatus == 0)
			return -1;
		else
			return -2;
        }
	return iCount;
}



//вызываемая функция анализа и 
//обработки запросов по сокетам
inline int	mwork(U8 * rbuf, U8 * sbuf)
{
	int 	res 	= 0;
	U8 	stype	= (*(U8*)(rbuf + _type));
	U8	scop	= (*(U8*)(rbuf + _cop));
	U16	ssize;//	= 0x02;
	
	//
	#if(_dbg > 0)
		printf("stype = %i  cop = %i\n", stype, scop);
	#endif
	//pthread_mutex_lock(&MainMutex);
	switch(stype)
	{
		case _type_from_modbus1:
			#if(_dbg > 0)
				printf("mwork ServConn for mb1\n");
			#endif
			switch(scop)
			{
				case _cop_wr:	//запись данных в труктуру Modbus 1
					//
					memcpy(&work.mb1s, rbuf + _daddr, sizeof(MODBUS1_SERVER));
					//
					(*(U16*)(sbuf + _tcp_szl))		= 0;
					res 					= 0;
					break;
				case _cop_rd:
					//возврат данных клиенту
					(*(U8*)(sbuf + _type))			= stype;
					//ssize++;
					(*(U8*)(sbuf + _cop))			= scop;
					//ssize++;
					ssize					= 0x04;
					//
					memcpy(sbuf + _daddr, &work.mb1c, sizeof(MODBUS1_CLIENT));
					ssize += sizeof(MODBUS1_CLIENT);
					//
					(*(U16*)(sbuf + _tcp_szl))		= ssize;
					res 					= ssize;
					break;
				case _cop_rdwr:
					//приём от клиента
					memcpy(&work.mb1s, rbuf + _daddr, sizeof(MODBUS1_SERVER));
					//возврат данных клиенту
					(*(U8*)(sbuf + _type))			= stype;
					//ssize++;
					(*(U8*)(sbuf + _cop))			= scop;
					//ssize++;
					ssize					= 0x04;
					//
					memcpy(sbuf + _daddr, &work.mb1c, sizeof(MODBUS1_CLIENT));
					ssize += sizeof(MODBUS1_CLIENT);
					//
					(*(U16*)(sbuf + _tcp_szl))		= ssize;
					res 					= ssize;
					break;
				default:
					(*(U16*)(sbuf + _tcp_szl))		= 0;
					res 					= 0;
					break;
			}
			break;
		case _type_from_modbus2:
			#if(_dbg > 0)
				printf("mwork ServConn for mb2\n");
			#endif
			switch(scop)
			{
				case _cop_wr:
					//
					memcpy(&work.mb2s, rbuf + _daddr, sizeof(MODBUS2_SERVER));
					//
					(*(U16*)(sbuf + _tcp_szl))		= 0;
					res 					= 0;
					break;
				case _cop_rd:	//передача данных в Modbus 2
					(*(U8*)(sbuf + _type))			= stype;
					//ssize++;
					(*(U8*)(sbuf + _cop))			= scop;
					//ssize++;
					ssize					= 0x04;
					//
					memcpy(sbuf + _daddr, &work.mb2c, sizeof(MODBUS2_CLIENT));
					ssize += sizeof(MODBUS2_CLIENT);
					//
					(*(U16*)(sbuf + _tcp_szl))		= ssize;
					res 					= ssize;
					break;
				case _cop_rdwr:
					//
					memcpy(&work.mb2s, rbuf + _daddr, sizeof(MODBUS2_SERVER));
					//
					//возврат данных клиенту
					(*(U8*)(sbuf + _type))			= stype;
					//ssize++;
					(*(U8*)(sbuf + _cop))			= scop;
					//ssize++;
					ssize					= 0x04;
					//
					memcpy(sbuf + _daddr, &work.mb2c, sizeof(MODBUS2_CLIENT));
					ssize += sizeof(MODBUS2_CLIENT);
					//
					(*(U16*)(sbuf + _tcp_szl))		= ssize;
					res 					= ssize;
					break;
				default:
					(*(U16*)(sbuf + _tcp_szl))		= 0;
					res 					= 0;
					break;
			}
			break;
		case _type_from_modbus3:
			#if(_dbg > 0)
				printf("mwork ServConn for mb3\n");
			#endif
			switch(scop)
			{
				case _cop_wr:	//запись данных в труктуру Modbus 3
					//
					memcpy(&work.mb3s, rbuf + _daddr, sizeof(MODBUS3_SERVER));
					//
					(*(U16*)(sbuf + _tcp_szl))		= 0;
					res 					= 0;
					break;
				case _cop_rd:	//передача данных в Modbus 3
					(*(U8*)(sbuf + _type))			= stype;
					//ssize++;
					(*(U8*)(sbuf + _cop))			= scop;
					//ssize++;
					ssize					= 0x04;
					//
					memcpy(sbuf + _daddr, &work.mb3c, sizeof(MODBUS3_CLIENT));
					ssize += sizeof(MODBUS3_CLIENT);
					//
					(*(U16*)(sbuf + _tcp_szl))		= ssize;
					res 					= ssize;
					break;
				case _cop_rdwr:	//передача данных в Modbus 3
					//
					memcpy(&work.mb3s, rbuf + _daddr, sizeof(MODBUS3_SERVER));
					//
					(*(U8*)(sbuf + _type))			= stype;
					//ssize++;
					(*(U8*)(sbuf + _cop))			= scop;
					//ssize++;
					ssize					= 0x04;
					//
					memcpy(sbuf + _daddr, &work.mb3c, sizeof(MODBUS3_CLIENT));
					ssize += sizeof(MODBUS3_CLIENT);
					//
					(*(U16*)(sbuf + _tcp_szl))		= ssize;
					res 					= ssize;
					break;
				default:
					(*(U16*)(sbuf + _tcp_szl))		= 0;
					res 					= 0;
					break;
			}
			break;
		case _type_from_modbus4:
			#if(_dbg > 0)
				printf("mwork ServConn for mb4\n");
			#endif
			switch(scop)
			{
				case _cop_wr:	//запись данных в труктуру Modbus 4
					//
					memcpy(&work.mb4s, rbuf + _daddr, sizeof(MODBUS4_SERVER));
					//
					(*(U16*)(sbuf + _tcp_szl))		= 0;
					res 					= 0;
					break;
				case _cop_rd:	//передача данных в Modbus 4
					(*(U8*)(sbuf + _type))			= stype;
					//ssize++;
					(*(U8*)(sbuf + _cop))			= scop;
					//ssize++;
					ssize					= 0x04;
					//
					memcpy(sbuf + _daddr, &work.mb4c, sizeof(MODBUS4_CLIENT));
					ssize += sizeof(MODBUS4_CLIENT);
					//
					(*(U16*)(sbuf + _tcp_szl))		= ssize;
					res 					= ssize;
					break;
				case _cop_rdwr:	//передача данных в Modbus 4
					//
					memcpy(&work.mb4s, rbuf + _daddr, sizeof(MODBUS4_SERVER));
					//
					(*(U8*)(sbuf + _type))			= stype;
					//ssize++;
					(*(U8*)(sbuf + _cop))			= scop;
					//ssize++;
					ssize					= 0x04;
					//
					memcpy(sbuf + _daddr, &work.mb4c, sizeof(MODBUS4_CLIENT));
					ssize += sizeof(MODBUS4_CLIENT);
					//
					(*(U16*)(sbuf + _tcp_szl))		= ssize;
					res 					= ssize;
					break;
				default:
					(*(U16*)(sbuf + _tcp_szl))		= 0;
					res 					= 0;
					break;
			}
			break;
		default:
			(*(U16*)(sbuf + _tcp_szl))	= 0;
			res 				= 0;
			break;
	}
	//pthread_mutex_unlock(&MainMutex);
	//
	return res;
}

//поток клиента
void server_con(CSERV * cs)
{
	int		countlive;
	int		setcntlive;
	int		csock;
	int		idclient;
	//int		rd;
	pthread_t	pth;
	U8		midcl;
	U8		rxbuf[_size_buf];
	U8		txbuf[_size_buf];
	int		txsz 		= 0;
	U8		work;
	int		res;
	#if(_deb_con == 1)
		printf("ServConn client connected\n");
	#endif

	pthread_mutex_lock(&ServerMutex);

	countlive 	= cs->setcntlive;
	setcntlive	= cs->setcntlive;
	csock		= cs->csock;
	idclient	= cs->idclient;
	midcl		= cs->midcl[idclient];
	pth		= cs->pth[idclient];
	work		= cs->work;
	//
	pthread_mutex_unlock(&ServerMutex);
	//
	#if(_deb_con == 1)
		printf("ServConn client connected and starting...\n");
	#endif
	//

/*	rd = pthread_detach(pth);
	if(rd > 0);
	{
		printf("Error DETACH !!! %i\n", rd);
		work = 0;
	}
*/	//
	while(work)
	{
		#if(_deb_con > 0)
			printf("client_countlive: %i\n", countlive);
		#endif
		//чтение сокета
		txsz = 0;
		memset(&rxbuf[0], 0, _size_buf);
		//pthread_mutex_unlock(&ServerMutex);
		res = ReadSocket(csock, &rxbuf[0]);
		//pthread_mutex_lock(&ServerMutex);
		switch(res)
		{
			case 0:	//Null
				break;
			case -1: //таймаут
				#if(_deb_con == 1)
					printf("TCP recv.:%i timeout..\r\n",midcl);
				#endif
				break;
			case -2: //какая-то ошибка сокета
				#if(_deb_con == 1)
					printf("TCP resv.:%i err?..\r\n",midcl);
				#endif
				goto mexit;
			case -3: //ошибка размера пакета
				//передача сообщения о несоответствии
				#if(_deb_con == 1)
					printf("TCP client:%i frame no correct..\r\n",midcl);
				#endif
				//goto mexit; //отмена обработки запроса
				break;
			default: //нормально - данные приняты
				countlive = setcntlive;
				//обработка команд и данных сокета
				#if(_deb_con == 1)
					printf("---starting mwork...\n");
				#endif
				pthread_mutex_lock(&MainMutex);
				txsz = mwork(&rxbuf[0], &txbuf[0]);
				pthread_mutex_unlock(&MainMutex);
				//if(txsz == 0)
				//	continue;
				break;
		}
		//передача данных
		if(txsz > 0)
		{
			//pthread_mutex_unlock(&ServerMutex);
			res = WriteSocket(csock, &txbuf[0], txsz);
			switch(res)
			{
				case 0:
					break;
				case -1:		//таймаут
					break;
				case -2:
					#if(_deb_con == 1)
						printf("TCP send.:%i err?..\r\n",midcl);
					#endif
					goto mexit;
				default:
					countlive = setcntlive;
					continue;
					break;
			}
			//pthread_mutex_lock(&ServerMutex);
		}
		//ожидание и новый цикл
		//pthread_mutex_unlock(&ServerMutex);
		usleep(_conn_sleep);
		countlive--;
		if(!(countlive > 0)) //никому это соединение не нужно
			break;
		pthread_mutex_lock(&ServerMutex);
		work	= cs->work; //кто-то сказал НЕ РАБОТАТЬ!
		pthread_mutex_unlock(&ServerMutex);
	}
mexit:	close(csock);
	pthread_mutex_lock(&ServerMutex);
	cs->midcl[idclient] = 0;
	cs->cntclient--;
	pthread_mutex_unlock(&ServerMutex);
	//return 0;
	pthread_exit(0); 
}

