//ServConn.h

#ifndef _serv_conn_
#define _serv_conn_

#include "types.h"
#include "main.h"
#include "config.h"

/*
********************
* для всех пакетов *
********************
*/
//начальные адреса пакета
#define _tcp_szl		0x0000		//младший байт размера
#define _tcp_szh		0x0001		//старший байт размера
#define _type			0x0002		//тип обращения
#define _cop			0x0003		//код операции
//команда для _cop
#define	_cop_rd			0x01		//чтение
#define _cop_wr			0x02		//запись
#define _cop_rdwr		0x03		//чтение-запись
//
#define _daddr			0x0004		//начало данных


#define _size_buf		1024		//размер буфера для приёма и передачи по TCP


typedef struct _CSERV
{
	U8			work;			//флаг работы по сокетам
	int			cntclient;		//счётчик клиентов для
	int			idclient;		//номер-идентификатор клиента в массиве
	U8			midcl[_max_sock];	//массив флагов активности клиентов
	pthread_t       	pth[_max_sock];		//массив потоков
	pthread_attr_t 		tattr[_max_sock];	//массив атрибутов потоков
	int			csock;			//сокет клиента
	U32			setcntlive;		//установка счётчика жизни сокета
}CSERV;

extern CSERV cserver;

extern int ipport;

//запуск сервера
extern int	server_start(int ipp);
//процесс прослушивания
void	server_listen(void);
//процесс соединения
void	server_con(CSERV * w);
/*
inline int WriteSocket(int nSocket, BYTE *pBuffer, U16 iMessageLength)
{
 	int 		iCount		= 0;
        int 		iSC 		= 0;
        int 		iSendStatus 	= 0;
        struct timeval 	SendTimeout;
        fd_set 		fds;
	//fcntl(nSocket, F_SETFL, O_NONBLOCK);
        while(iMessageLength > 0)
        {
		//установка величины таймаута
        	SendTimeout.tv_sec  = 0;
        	SendTimeout.tv_usec = _SOCKET_TIMEOUT_;
        	FD_ZERO(&fds);
        	FD_SET(nSocket, &fds);
                iSC = select(nSocket + 1, NULL, &fds, NULL, &SendTimeout);
                if(!iSC)
                        return -1; //таймаут
                if(iSC < 0)
                        return -2; //ошибка
		//отправить несколько байт
		#if(_tcp_send_deb == 1)
			printf("----write sock (send) ----\r\n");
                #endif
		iSendStatus = send(nSocket, (char*)(pBuffer), iMessageLength, 0);
                if(iSendStatus > 0)
                {
                        //обновить буфер и счетчик
                        iMessageLength -= iSendStatus;
                        pBuffer += iSendStatus;
                        iCount += iSendStatus;
                }
		else if(iSendStatus == 0)
			return -1;
		else
			return -2;
        }
	return iCount;
}
*/


/*
inline int ReadSocket(int nSocket, BYTE *pBuffer)
{
        //int     res                     = 1;
        int     	iRC                     = 0;
        int     	iReceiveStatus          = 0;
        int     	iStillToReceive         = 2; //начальный размер получения минимальных данных
        int     	iCount = 0;
        struct timeval 	ReceiveTimeout;
        fd_set 		fds;
	U8		flag			= 0;
	//fcntl(nSocket, F_SETFL, O_NONBLOCK);
        //fds = calloc(1, sizeof(fd_set));// fds;
        //int size = 0;
        while(iStillToReceive > 0)
        {
                //установка величины таймаута
                FD_ZERO(&fds);
                FD_SET(nSocket, &fds);
                ReceiveTimeout.tv_sec  = 0;
                ReceiveTimeout.tv_usec = _SOCKET_TIMEOUT_;
                iRC = select(nSocket + 1, &fds, NULL, NULL, &ReceiveTimeout);
                //выход по таймауту
                if(!iRC)
			return -1;
		//произошла какая то ошибка
                if(iRC < 0)
                        return -2;
		//ошибка указания размера данных
                if(iStillToReceive <= 0)
                        return -3;
                //прием нескольких байт
		#if(_tcp_recv_deb == 1)
			printf("----read sock (recv) ----\r\n");
        	#endif
		iReceiveStatus = recv(nSocket, (char*)(pBuffer), iStillToReceive, 0);
                if(iReceiveStatus >  0)
                {
			pBuffer += iReceiveStatus;
                        iStillToReceive -= iReceiveStatus;
                        iCount += iReceiveStatus;
			if((iCount >= 2) && (flag == 0))
			{ 
				iStillToReceive = (*(U16*)(pBuffer - iCount)) - iCount;
				#if(_tcp_recv_deb == 1)
					printf("---recv size: set %i, count %i, still %i\r\n", (*(U16*)(pBuffer - iCount)), iCount, iStillToReceive);
				#endif
				flag = 0xFF;
			}
                }
		else if(iReceiveStatus == 0)
			return -1;
		else
			return -2;
		#if(_tcp_recv_deb == 1)
			printf("==iStillToReceive:%i iCount:%i==\r\n", iStillToReceive, iCount);
		#endif
        }
        //
        return iCount;
}
*/


#endif

