//main.c

#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/time.h>
#include <pthread.h>
#include "config.h"
#include <stdio.h>
#include <string.h>
#include "types.h"
#include "main.h"
#include "ServConn.h"


WORK			work;
pthread_mutex_t         MainMutex;
char 			FServConn[255];
int 			scnt;


int main(int argc, char **argv)
{
	int res;
	int Y,M,D;
	#if(_mdbg > 0)
		U32	mdbgcnt	= (1000000 / _main_sleep);
	#endif
	//char str1[5], str2[5];
	scnt = 1;
	//
	if(argc < 2)
	{
		printf(__err1__);
		return 1;
	}
	//
	while (scnt < argc)
	{
		//подсказка
		if(strcmp(argv[scnt], "--help") == 0)
		{
			printf(__help__);
			return 0;
		}
		//версия
		else if(strcmp(argv[scnt], "--version") == 0)
		{
			D = _ServConn_date_ & 0xFF;
			M = (_ServConn_date_ >> 8) & 0xFF;
			Y = (_ServConn_date_ >> 16) & 0xFFFF;
			printf("\nServConn: version:%.2f data:%.2X.%.2X.%.4X\n", _ServConn_version_, D, M, Y);
			//
			return 0;
		}
		//порт соединений
                else if(strcmp(argv[scnt], "-p") == 0)
                {
                        scnt++;
                        if(!(scnt < argc))
                                return 2;
                        ipport = atoi(argv[scnt]);
                        if(ipport == 0)
                                return 3;
                }
		//файл данных
                else if(strcmp(argv[scnt], "-fd") == 0)
                {
                        scnt++;
                        if(!(scnt < argc))
                                return 2;
                        memset(&FServConn[0], 0, 255);
                        strcpy(&FServConn[0], argv[scnt]);
                }
		else
		{
			printf(__err2__);
			return 2;
		}
		scnt++;
	}
	//
	//mutex create
        if(!(pthread_mutex_init(&MainMutex,NULL) == 0))
                return 4;
        //подключение
        res = server_start(ipport);
        printf("---- opening listen  %u ----\r\n", ipport);
        switch(res)
        {
                case 0:
                        break;
                default:
                        printf("----STARTING LISTEN ERROR : %i------\r\n", res);
                        return 255;
        }
	//=== инициализация параметров ====
	work.id				= 0;
	work.pr_speed_m1_min		= _pr_speed_m1_min;//3.0;
	work.pr_speed_m1_max		= _pr_speed_m1_max;
	work.StepSpeedLenghtUp_m1	= _StepSpeedLenghtUp_m1;//45.0;
	work.StepSpeedLenghtWown_m1	= _StepSpeedLenghtWown_m1;//45.0;
	work.mb3c.SetLenghtMin		= _SetLenghtMin_m1;
	work.mb3c.SetLenghtMax		= _SetLenghtMax_m1;
	work.SetLenghtDeltaStart_m1	= _SetLenghtDeltaStart_m1;
	work.SetLenghtDeltaStop_m1	= _SetLenghtDeltaStop_m1;
	work.pr_speed_m2_min		= _pr_speed_m2_min;//1.0;
	work.pr_speed_m2_max		= _pr_speed_m2_max;
	work.StepSpeedLenghtUp_m2	= _StepSpeedLenghtUp_m2;
	work.StepSpeedLenghtWown_m2	= _StepSpeedLenghtWown_m2;
	work.mb4c.SetLenghtMin		= _SetLenghtMin_m2;
	work.mb4c.SetLenghtMax		= _SetLenghtMax_m2;
	work.SetLenghtDeltaStart_m2	= _SetLenghtDeltaStart_m2;
	work.SetLenghtDeltaStop_m2	= _SetLenghtDeltaStop_m2;
	work.SI_30_correct		= _SI_30_correct;	//коррекция (множитель) счётчика СИ30
	//
	while(1)
	{
		pthread_mutex_lock(&MainMutex);
		/* цикл обмена данных соединений */
		//от Modbus 1
		work.mb1c.id				= work.mb1s.id;
		work.mb2c.Lenght			= work.mb1s.Lenght;		//измеренная длина в mb2
		work.mb2c.mk110_RdInmask		= work.mb1s.mk110_RdInmask;	//прочитанная маска входов в mb2
		work.mb2c.mk110_RdOutmask		= work.mb1s.mk110_RdOutmask;	//прочитанная маска выходов в mb2
		work.mb3c.Lenght			= work.mb1s.Lenght;		//измеренная длина в mb3
		work.mb4c.Lenght			= work.mb1s.Lenght;		//измеренная длина в mb4
		//от Modbus 2
		work.mb2c.id				= work.mb2s.id;
		work.mb1c.SetLenght			= work.mb2s.SetLenght;		//заданная длина в mb1
		work.mb3c.SetLenght			= work.mb2s.SetLenght;		//заданная длина в mb3
		work.mb4c.SetLenght			= work.mb2s.SetLenght;		//заданная длина в mb4
		work.mb1c.SetCntCut			= work.mb2s.SetCntCut;		//заданное количество отрезков в mb1
		work.mb1c.mk110_WrOutmaskSet		= work.mb2s.mk110_WrOutmaskSet;	//задание маски установки выходов в mb1
		work.mb1c.mk110_WrOutmaskClr		= work.mb2s.mk110_WrOutmaskClr; //задание маски сброса выходов в mb1
		//от Modbus 3
		work.mb3c.id				= work.mb3s.id;
		//от Modbus 4
		work.mb4c.id				= work.mb4s.id;
		//для ведущего Modbus 1
		work.mb1c.SI_30_correct			= work.SI_30_correct;
		work.mb1c.mode				= (work.mb2s.stat | work.mb3s.stat | work.mb4s.stat);
		work.mb1c.pr_speed_m1_min		= work.pr_speed_m1_min;
		work.mb1c.pr_speed_m1_max		= work.pr_speed_m1_max;
		work.mb1c.pr_speed_m2_min		= work.pr_speed_m2_min;
		work.mb1c.pr_speed_m2_max		= work.pr_speed_m2_max;
		work.mb1c.ErrSetLenghtM1		= work.mb2s.ErrSetLenghtM1;
		work.mb1c.ErrSetLenghtM2		= work.mb2s.ErrSetLenghtM2;
		//для Modbus 2
		work.mb2c.mode				= work.mb1s.stat;		//
		work.mb2c.CntCut			= work.mb1s.CntCut;
		//для Modbus 3
		work.mb3c.mode				= work.mb1s.stat;
		work.mb3c.pr_speed_m1			= work.mb1s.pr_speed_m1;	//
		work.mb3c.pr_speed_m1_min		= work.pr_speed_m1_min;
		work.mb3c.pr_speed_m1_max		= work.pr_speed_m1_max;
		work.mb3c.SetLenghtDeltaStart		= work.SetLenghtDeltaStart_m1;
		work.mb3c.SetLenghtDeltaStop		= work.SetLenghtDeltaStop_m1;
		work.mb3c.StepSpeedLenghtUp		= work.StepSpeedLenghtUp_m1;
		work.mb3c.StepSpeedLenghtWown		= work.StepSpeedLenghtWown_m1;
		work.mb3c.ErrSetLenghtM1		= work.mb2s.ErrSetLenghtM1;
		//для Modbus 4
		work.mb4c.mode				= work.mb1s.stat;
		work.mb4c.pr_speed_m2			= work.mb1s.pr_speed_m2;	//
		work.mb4c.pr_speed_m2_min		= work.pr_speed_m2_min;
		work.mb4c.pr_speed_m2_max		= work.pr_speed_m2_max;
		work.mb4c.SetLenghtDeltaStart		= work.SetLenghtDeltaStart_m2;
		work.mb4c.SetLenghtDeltaStop		= work.SetLenghtDeltaStop_m2;
		work.mb4c.StepSpeedLenghtUp		= work.StepSpeedLenghtUp_m2;
		work.mb4c.StepSpeedLenghtWown		= work.StepSpeedLenghtWown_m2;
		work.mb4c.ErrSetLenghtM2		= work.mb2s.ErrSetLenghtM2;
		//work.mb3.fref = work.mb1.pr_speed_m1;
		#if(_mdbg > 0)
			if(mdbgcnt < 1)
			{
			printf("\n---\t\t\t\t----------ServConn--------\t\t\t\t---\n");
			printf("mb1 IDfr: %.8X\tmb2 IDfr: %.8X\tmb3 IDfr: %.8X\tmb4 IDfr: %.8X\t---ID From\n", 
			work.mb1s.id, work.mb2s.id, work.mb3s.id, work.mb4s.id);
			printf("mb1 IDto: %.8X\tmb2 IDto: %.8X\tmb3 IDto: %.8X\tmb4 IDto: %.8X\t---ID To\n", 
			work.mb1c.id, work.mb2c.id, work.mb3c.id, work.mb4c.id);
			printf("mb1 stat: %.8X\tmb2 stat: %.8X\tmb3 stat: %.8X\tmb4 stat: %.8X\t---stat\n", 
			work.mb1s.stat, work.mb2s.stat, work.mb3s.stat, work.mb4s.stat);
			printf("mb1 mode: %.8X\tmb2 mode: %.8X\tmb3 mode: %.8X\tmb4 mode: %.8X\t---mode\n", 
			work.mb1c.mode, work.mb2c.mode, work.mb3c.mode, work.mb4c.mode);
			printf("mb1 Lght: %f\tmb2 Lght: %f\tmb3 Lght: %f\tmb4 Lght: %f\t---Lenght\n", 
			work.mb1s.Lenght, work.mb2c.Lenght, work.mb3c.Lenght, work.mb4c.Lenght);
			printf("mb1 SLgt: %f\tmb2 SLgt: %f\tmb3 SLgt: %f\tmb4 SLgt: %f\t---Set Lenght\n",
			work.mb1c.SetLenght, work.mb2s.SetLenght, work.mb3c.SetLenght, work.mb1c.SetLenght);
			printf("mb1eLgt1: %f\tmb2eLgt1: %f\tmb3eLgt1: %f\t------------------\t---Set Err Correct Lenght M1\n",
			work.mb1c.ErrSetLenghtM1, work.mb2s.ErrSetLenghtM1, work.mb3c.ErrSetLenghtM1);
			printf("mb1eLgt2: %f\tmb2eLgt2: %f\t------------------\tmb4eLgt2: %f\t---Set Err Correct Lenght M2\n",
			work.mb1c.ErrSetLenghtM2, work.mb2s.ErrSetLenghtM2, work.mb4c.ErrSetLenghtM2);
			printf("mb1 SCCt: %.8u\tmb2 SCCt: %.8u\t------------------\t------------------\t---Set Cnt Cut\n",
			work.mb1c.SetCntCut, work.mb2s.SetCntCut);
			printf("mb1 CntC: %.8u\tmb2 CntC: %.8u\t------------------\t------------------\t---Cnt Cut\n",
			work.mb1s.CntCut, work.mb2c.CntCut);
			printf("mb1_SPM1: %f\t------------------\tmb3_SPM1: %f\t------------------\t---pr_speed_m1\n",
			work.mb1s.pr_speed_m1, work.mb3c.pr_speed_m1);
			printf("mb1_SdM1: %f\t------------------\tmb3_SdM1: %f\t------------------\t---pr_speed_m1_min\n",
			work.mb1c.pr_speed_m1_min, work.mb3c.pr_speed_m1_min);
			printf("mb1_SuM1: %f\t------------------\tmb3_SuM1: %f\t------------------\t---pr_speed_m1_max\n",
			work.mb1c.pr_speed_m1_max, work.mb3c.pr_speed_m1_max);
			printf("------------------\t------------------\tmb3_SLu1: %f\t------------------\t---StepSpeedLenghtUp_m1\n",
			work.mb3c.StepSpeedLenghtUp);
			printf("------------------\t------------------\tmb3_SLd1: %f\t------------------\t---StepSpeedLenghtDown_m1\n",
			work.mb3c.StepSpeedLenghtWown);
			printf("------------------\t------------------\tmb3_DSR1: %f\t------------------\t---SetLenghtDeltaStart_m1\n",
			work.mb3c.SetLenghtDeltaStart);
			printf("------------------\t------------------\tmb3_DST1: %f\t------------------\t---SetLenghtDeltaStop_m1\n",
			work.mb3c.SetLenghtDeltaStop);
			printf("mb1_SPM2: %f\t------------------\t------------------\tmb4_SPM2: %f\t---pr_speed_m2\n",
			work.mb1s.pr_speed_m2, work.mb4c.pr_speed_m2);
			printf("mb1_SdM2: %f\t------------------\t------------------\tmb4_SdM2: %f\t---pr_speed_m2_min\n",
			work.mb1c.pr_speed_m2_min, work.mb4c.pr_speed_m2_min);
			printf("mb1_SuM2: %f\t------------------\t------------------\tmb4_SuM2: %f\t---pr_speed_m2_max\n",
			work.mb1c.pr_speed_m2_max, work.mb4c.pr_speed_m2_max);
			printf("------------------\t------------------\t------------------\tmb4_SLu2: %f\t---StepSpeedLenghtUp_m2\n",
			work.mb4c.StepSpeedLenghtUp);
			printf("------------------\t------------------\t------------------\tmb4_SLd2: %f\t---StepSpeedLenghtDown_m2\n",
			work.mb4c.StepSpeedLenghtWown);
			printf("------------------\t------------------\t------------------\tmb4_DSR2: %f\t---SetLenghtDeltaStart_m2\n",
			work.mb4c.SetLenghtDeltaStart);
			printf("------------------\t------------------\t------------------\tmb4_DST2: %f\t---SetLenghtDeltaStop_m2\n",
			work.mb4c.SetLenghtDeltaStop);
			//
			mdbgcnt	= (1000000 / _main_sleep);
			}
			else
				mdbgcnt--;
		#endif
		//
		pthread_mutex_unlock(&MainMutex);
		usleep(_main_sleep);
	}
	return 0;
}



/*
//вызываемая функция анализа и 
//обработки запросов по сокетам
inline int	mwork(U8 * rbuf, U8 * sbuf)
{
	int 	res 	= 0;
	U8 	stype	= (*(U8*)(rbuf + _type));
	U8	scop	= (*(U8*)(rbuf + _cop));
	U16	ssize	= 0x02;
	
	//
	#if(_dbg > 0)
		printf("stype = %i  cop = %i\n", stype, scop);
	#endif
	pthread_mutex_lock(&MainMutex);
	switch(stype)
	{
		case _type_from_modbus1:
			#if(_dbg > 0)
				printf("mwork ServConn for mb1\n");
			#endif
			switch(scop)
			{
				case _cop_wr:	//запись данных в труктуру Modbus 1
					//
					memcpy(&work.mb1s, rbuf + _daddr, sizeof(MODBUS1_SERVER));
					//
					(*(U16*)(sbuf + _tcp_szl))		= 0;
					res 					= 0;
					break;
				case _cop_rd:
					//возврат данных клиенту
					(*(U8*)(sbuf + _type))			= stype;
					ssize++;
					(*(U8*)(sbuf + _cop))			= scop;
					ssize++;
					//
					memcpy(sbuf + _daddr, &work.mb1c, sizeof(MODBUS1_CLIENT));
					ssize += sizeof(MODBUS1_CLIENT);
					//
					(*(U16*)(sbuf + _tcp_szl))		= ssize;
					res 					= ssize;
					break;
				case _cop_rdwr:
					//приём от клиента
					memcpy(&work.mb1s, rbuf + _daddr, sizeof(MODBUS1_SERVER));
					//возврат данных клиенту
					(*(U8*)(sbuf + _type))			= stype;
					ssize++;
					(*(U8*)(sbuf + _cop))			= scop;
					ssize++;
					//
					memcpy(sbuf + _daddr, &work.mb1c, sizeof(MODBUS1_CLIENT));
					ssize += sizeof(MODBUS1_CLIENT);
					//
					(*(U16*)(sbuf + _tcp_szl))		= ssize;
					res 					= ssize;
					break;
				default:
					(*(U16*)(sbuf + _tcp_szl))		= 0;
					res 					= 0;
					break;
			}
			break;
		case _type_from_modbus2:
			#if(_dbg > 0)
				printf("mwork ServConn for mb2\n");
			#endif
			switch(scop)
			{
				case _cop_wr:
					//
					memcpy(&work.mb2s, rbuf + _daddr, sizeof(MODBUS2_SERVER));
					//
					(*(U16*)(sbuf + _tcp_szl))	= 0;
					res 				= 0;
					break;
				case _cop_rd:	//передача данных в Modbus 2
					(*(U8*)(sbuf + _type))			= stype;
					ssize++;
					(*(U8*)(sbuf + _cop))			= scop;
					ssize++;
					//
					memcpy(sbuf + _daddr, &work.mb2c, sizeof(MODBUS2_CLIENT));
					ssize += sizeof(MODBUS2_CLIENT);
					//
					(*(U16*)(sbuf + _tcp_szl))		= ssize;
					res 					= ssize;
					break;
				case _cop_rdwr:
					//
					memcpy(&work.mb2s, rbuf + _daddr, sizeof(MODBUS2_SERVER));
					//
					//возврат данных клиенту
					(*(U8*)(sbuf + _type))			= stype;
					ssize++;
					(*(U8*)(sbuf + _cop))			= scop;
					ssize++;
					//
					memcpy(sbuf + _daddr, &work.mb2c, sizeof(MODBUS2_CLIENT));
					ssize += sizeof(MODBUS2_CLIENT);
					//
					(*(U16*)(sbuf + _tcp_szl))		= ssize;
					res 					= ssize;
					break;
				default:
					(*(U16*)(sbuf + _tcp_szl))		= 0;
					res 					= 0;
					break;
			}
			break;
		case _type_from_modbus3:
			#if(_dbg > 0)
				printf("mwork ServConn for mb3\n");
			#endif
			switch(scop)
			{
				case _cop_wr:	//запись данных в труктуру Modbus 3
					//
					memcpy(&work.mb3s, rbuf + _daddr, sizeof(MODBUS3_SERVER));
					//
					(*(U16*)(sbuf + _tcp_szl))		= 0;
					res 					= 0;
					break;
				case _cop_rd:	//передача данных в Modbus 3
					(*(U8*)(sbuf + _type))			= stype;
					ssize++;
					(*(U8*)(sbuf + _cop))			= scop;
					ssize++;
					//
					memcpy(sbuf + _daddr, &work.mb3c, sizeof(MODBUS3_CLIENT));
					ssize += sizeof(MODBUS3_CLIENT);
					//
					(*(U16*)(sbuf + _tcp_szl))		= ssize;
					res 					= ssize;
					break;
				case _cop_rdwr:	//передача данных в Modbus 3
					//
					memcpy(&work.mb3s, rbuf + _daddr, sizeof(MODBUS3_SERVER));
					//
					(*(U8*)(sbuf + _type))			= stype;
					ssize++;
					(*(U8*)(sbuf + _cop))			= scop;
					ssize++;
					//
					memcpy(sbuf + _daddr, &work.mb3c, sizeof(MODBUS3_CLIENT));
					ssize += sizeof(MODBUS3_CLIENT);
					//
					(*(U16*)(sbuf + _tcp_szl))		= ssize;
					res 					= ssize;
					break;
				default:
					(*(U16*)(sbuf + _tcp_szl))		= 0;
					res 					= 0;
					break;
			}
		case _type_from_modbus4:
			#if(_dbg > 0)
				printf("mwork ServConn for mb4\n");
			#endif
			switch(scop)
			{
				case _cop_wr:	//запись данных в труктуру Modbus 4
					//
					memcpy(&work.mb4s, rbuf + _daddr, sizeof(MODBUS4_SERVER));
					//
					(*(U16*)(sbuf + _tcp_szl))		= 0;
					res 					= 0;
					break;
				case _cop_rd:	//передача данных в Modbus 4
					(*(U8*)(sbuf + _type))			= stype;
					ssize++;
					(*(U8*)(sbuf + _cop))			= scop;
					ssize++;
					//
					memcpy(sbuf + _daddr, &work.mb4c, sizeof(MODBUS4_CLIENT));
					ssize += sizeof(MODBUS4_CLIENT);
					//
					(*(U16*)(sbuf + _tcp_szl))		= ssize;
					res 					= ssize;
					break;
				case _cop_rdwr:	//передача данных в Modbus 4
					//
					memcpy(&work.mb4s, rbuf + _daddr, sizeof(MODBUS4_SERVER));
					//
					(*(U8*)(sbuf + _type))			= stype;
					ssize++;
					(*(U8*)(sbuf + _cop))			= scop;
					ssize++;
					//
					memcpy(sbuf + _daddr, &work.mb4c, sizeof(MODBUS4_CLIENT));
					ssize += sizeof(MODBUS4_CLIENT);
					//
					(*(U16*)(sbuf + _tcp_szl))		= ssize;
					res 					= ssize;
					break;
				default:
					(*(U16*)(sbuf + _tcp_szl))		= 0;
					res 					= 0;
					break;
			}
			break;
		default:
			(*(U16*)(sbuf + _tcp_szl))	= 0;
			res 				= 0;
			break;
	}
	pthread_mutex_unlock(&MainMutex);
	//
	return res;
}
*/

