//main.h

#ifndef _main_h_
#define _main_h_

#define _ServConn_version_		1.02
#define _ServConn_date_			0x20160809

/*
	02.08.2016	- изменение процесса прослушивания - ускорение
*/


#include "types.h"
#include "ServConn.h"


#define __err1__	"\nERROR!: Not defined parametr(s)!\n\"--help\" for information\n"
#define __err2__	"\nERROR!: Uncnown argument(s)!\n\"--help\" for information\n"

#define __help__	"\n\
       --help             - Current informaton\n\
       --version          - Version info\n\
\n\
       -ip <ip addr>      - \"ip addr\" - ip address of Server Modbus RTU\n\
       -p <port>          - \"port\" - ip port listening of Connects Server\n\
\n\
       -fm <file_name>    - \"file_name\" - name file for output data from module modbus 1\n\
       -fc <file_name>    - \"file_name\" - name file for config setting\n\
\n"


/*
***********************
*   формат пакета     *
***********************
*/
//=== для пакета данных от Modbus1 ===
#define _type_from_modbus1	0x10			//данные от Modbus1
//=== для пакета данных от Modbus2 ===
#define _type_from_modbus2	0x20			//данные от Modbus2
//=== для пакета данных от Modbus3 ===
#define _type_from_modbus3	0x30			//данные от Modbus3
//=== для пакета данных от Modbus4 ===
#define _type_from_modbus4	0x40			//данные от Modbus4

//----------------------------------------------------------------------------


//структура для Modbus 1 - для клиента
typedef struct _MODBUS1_CLIENT
{
	float	SetLenght;			//заданная длина
	float	SetLenghtDeltaStart_m1;		//заданная длина после старта - регулировка протяжки
	float	SetLenghtDeltaStop_m1;		//заданная длина до стопа - регулировка	протяжки	
	float	SetLenghtMin;			//минимальная заданная длина
	float	SetLenghtDeltaStart_m2;		//заданная длина после старта - регулировка намотки
	float	SetLenghtDeltaStop_m2;		//заданная длина до стопа - регулировка	намотки
	float	SetLenghtMax;			//максимальная заданная длина
	float	pr_speed_m1_min;		//минимальное задание протяжки
	float	pr_speed_m1_max;		//максимальное задание протяжки
	float	pr_speed_m1;			//внешнее задание в процентах протяжки
	float	pr_speed_m2_min;		//минимальное задание намотки
	float	pr_speed_m2_max;		//максимальное задание намотки
	float	pr_speed_m2;			//внешнее задание в процентах намотки
	float	SI_30_correct;			//коррекция (множитель) счётчика СИ30
	float	ErrSetLenghtM1;
	float	ErrSetLenghtM2;
	U32	id;
#define _mb1_mode_reserve1	_bit_0		//---есть связь с устройством ввода-вывода
#define _mb1_mode_reserve2	_bit_1		//---есть связь со счётчиком 
#define _mb1_mode_reserve3	_bit_2		//---есть связь с устройством аналогового ввода
#define _mb1_mode_conn_m1	_bit_3		//есть связь с приводом протяжки
#define _mb1_mode_conn_m2	_bit_4		//есть связь с приводом намотки
#define _mb1_mode_conn_ip320	_bit_5		//есть связь с панелью ИП320
#define _mb1_mode_reserve4	_bit_6		//---активность сигнала ножниц
#define _mb1_mode_reserve5	_bit_7		//---позиция ножниц НИЗ
#define _mb1_mode_reserve6	_bit_8		//---позиция ножниц ВЕРХ
#define _mb1_mode_m1_work	_bit_9		//активность привода протяжки
#define _mb1_mode_m2_work	_bit_10		//активность привода намотки
#define _mb1_mode_m1end		_bit_11		//протяжка завершена
#define _mb1_mode_m2end		_bit_12		//намотка завершена
#define _mb1_mode_reserve7	_bit_13		//---кусок отрезан
#define _mb1_mode_mode_m1	_bit_14		//режим протяжки
#define _mb1_mode_mode_m2	_bit_15		//режим намотки
#define _mb1_mode_stop		_bit_16		//режим останова
#define	_mb1_mode_work		_bit_17		//режим работы
#define _mb1_mode_reserve8	_bit_18		//---активность рабочего цикла
#define _mb1_mode_reserve9	_bit_19		//---рабочий кикл завершен
#define _mb1_mode_reserve10	_bit_20		//---кнопка пуск
#define _mb1_mode_reserve11	_bit_21		//---кнопка стоп
#define _mb1_mode_cutdbg	_bit_22		//отладка ножниц
#define _mb1_mode_reserve13	_bit_23
#define _mb1_mode_reserve14	_bit_24
#define _mb1_mode_errconn	_bit_25		//ошибка связи
#define _mb1_mode_reserve15	_bit_26		//---ошибка ножниц
#define _mb1_mode_reserve16	_bit_27		//---ошибка кнопок
#define _mb1_mode_err_m1	_bit_28		//ошибка привода протяжки
#define _mb1_mode_err_m2	_bit_29		//ошибка привода намотки
#define _mb1_mode_errparam	_bit_30		//ошибка параметров
#define _mb1_mode_error		_bit_31		//ошибка или авария
	U32	mode;				//числовой идентификатор режима работы
	U16	SetCntCut;			//заданное количество отрезков
	U16	mk110_WrOutmaskSet;		//маска установки выходов
	U16	mk110_WrOutmaskClr;		//маска сброса выходов
} MODBUS1_CLIENT;

//структура для Modbus 1 - для сервера
typedef struct _MODBUS1_SERVER
{
	float	Lenght;				//измеренная длина
	float	pr_speed_m1;			//задание протяжки
	float	pr_speed_m2;			//задание намотки
	float	an_speed_m2;			//задание намотки от джойстика
	U32	id;
	//
#define _mb1_stat_conn_mk110	_bit_0		//есть связь с устройством ввода-вывода
#define _mb1_stat_conn_si30	_bit_1		//есть связь со счётчиком 
#define _mb1_stat_conn_mv110	_bit_2		//есть связь с устройством аналогового ввода
#define _mb1_stat_reserve1	_bit_3		//---есть связь с приводом протяжки
#define _mb1_stat_reserve2	_bit_4		//---есть связь с приводом намотки
#define _mb1_stat_reserve3	_bit_5		//---есть связь с панелью ИП320
#define _mb1_stat_cut_out	_bit_6		//активность сигнала ножниц
#define _mb1_stat_cut_down	_bit_7		//позиция ножниц НИЗ
#define _mb1_stat_cut_up	_bit_8		//позиция ножниц ВЕРХ
#define _mb1_stat_reserve4	_bit_9		//---активность привода протяжки
#define _mb1_stat_reserve5	_bit_10		//---активность привода намотки
#define _mb1_stat_reserve6	_bit_11		//---протяжка завершена
#define _mb1_stat_reserve7	_bit_12		//---намотка завершена
#define _mb1_stat_cutend	_bit_13		//кусок отрезан
#define _mb1_stat_mode_m1	_bit_14		//режим протяжки
#define _mb1_stat_mode_m2	_bit_15		//режим намотки
#define _mb1_stat_stop		_bit_16		//состояние останова
#define	_mb1_stat_work		_bit_17		//coстояние работы
#define _mb1_stat_work_loop	_bit_18		//активность рабочего цикла
#define _mb1_stat_work_loop_end	_bit_19		//рабочий кикл завершен
#define _mb1_stat_keyon		_bit_20		//кнопка пуск
#define _mb1_stat_keyoff	_bit_21		//кнопка стоп
#define _mb1_stat_cutdbg	_bit_22		//отладка ножниц
#define _mb1_stat_reserve9	_bit_23
#define _mb1_stat_reserve10	_bit_24
#define _mb1_stat_errconn	_bit_25		//ошибка связи
#define _mb1_stat_cuterr	_bit_26		//ошибка ножниц
#define _mb1_stat_keyerr	_bit_27		//ошибка кнопок
#define _mb1_stat_reserve11	_bit_28		//---ошибка привода протяжки
#define _mb1_stat_reserve12	_bit_29		//---ошибка привода намотки
#define _mb1_stat_errparam	_bit_30		//ошибка параметров
#define _mb1_stat_error		_bit_31		//ошибка или авария
	U32	stat;				//состояние
	U16	CntCut;				//количество готовых отрезков
#define _rdin_key_on		_bit_6
#define _rdin_key_off		_bit_7
#define _rdin_key_cutup		_bit_2
#define _rdin_key_cutdown	_bit_3
	U16	mk110_RdInmask;			//маска входов устройства ввода
#define _mk110_cut		_bit_0		//ножницы
	U16	mk110_RdOutmask;		//маска прочитанных состояний выходов
} MODBUS1_SERVER;

//структура для Modbus 2 - для клиента
typedef struct _MODBUS2_CLIENT
{
	float	Lenght;				//измеренная длина;
	U32	id;
#define _mb2_mode_conn_mk110	_bit_0		//есть связь с устройством ввода-вывода
#define _mb2_mode_conn_si30	_bit_1		//есть связь со счётчиком 
#define _mb2_mode_conn_mv110	_bit_2		//есть связь с устройством аналогового ввода
#define _mb2_mode_conn_m1	_bit_3		//есть связь с приводом протяжки
#define _mb2_mode_conn_m2	_bit_4		//есть связь с приводом намотки
#define _mb2_mode_reserve1	_bit_5		//---есть связь с панелью ИП320
#define _mb2_mode_cut_out	_bit_6		//активность сигнала ножниц
#define _mb2_mode_cut_down	_bit_7		//позиция ножниц НИЗ - не отрез
#define _mb2_mode_cut_up	_bit_8		//позиция ножниц ВЕРХ - отрез
#define _mb2_mode_m1_work	_bit_9		//активность привода протяжки
#define _mb2_mode_m2_work	_bit_10		//активность привода намотки
#define _mb2_mode_m1end		_bit_11		//протяжка завершена
#define _mb2_mofe_m2end		_bit_12		//намотка завершена
#define _mb2_mode_cutend	_bit_13		//кусок отрезан
#define _mb2_mode_mode_m1	_bit_14		//режим протяжки
#define _mb2_mode_mode_m2	_bit_15		//режим намотки
#define _mb2_mode_stop		_bit_16		//режим останова
#define	_mb2_mode_work		_bit_17		//режим работы
#define _mb2_mode_work_loop	_bit_18		//активность рабочего цикла
#define _mb2_mode_work_loop_end	_bit_19		//рабочий кикл завершен
#define _mb2_mode_keyon		_bit_20		//кнопка пуск
#define _mb2_mode_keyoff	_bit_21		//кнопка стоп
#define _mb2_mode_cutdbg	_bit_22		//отладка ножниц
#define _mb2_mode_reserve7	_bit_23
#define _mb2_mode_reserve8	_bit_24
#define _mb2_mode_errconn	_bit_25		//ошибка связи
#define _mb2_mode_errcut	_bit_26		//ошибка ножниц
#define _mb2_mode_keyerr	_bit_27		//ошибка кнопок
#define _mb2_mode_err_m1	_bit_28		//ошибка привода протяжки
#define _mb2_mode_err_m2	_bit_29		//ошибка привода намотки
#define _mb2_mode_errparam	_bit_30		//ошибка параметров
#define _mb2_mode_error		_bit_31		//ошибка или авария
	U32	mode;
	U16	mk110_RdInmask;			//маска входов устройства ввода
#define _mk110_cut		_bit_0		//ножницы
	U16	mk110_RdOutmask;		//маска прочитанных состояний выходов
	U16	CntCut;				//готовое количество
} MODBUS2_CLIENT;

//структура для Modbus 2 - для сервера
typedef struct _MODBUS2_SERVER
{
	float	SetLenght;			//задание длины
	float	ErrSetLenghtM1;
	float	ErrSetLenghtM2;
	U32	id;
#define _mb2_stat_reserve1	_bit_0		//---есть связь с устройством ввода-вывода
#define _mb2_stat_reserve2	_bit_1		//---есть связь со счётчиком 
#define _mb2_stat_reserve3	_bit_2		//---есть связь с устройством аналогового ввода
#define _mb2_stat_reserve4	_bit_3		//---есть связь с приводом протяжки
#define _mb2_stat_reserve4_2	_bit_4		//---есть связь с приводом намотки
#define _mb2_stat_conn_ip320	_bit_5		//есть связь с панелью ИП320
#define _mb2_stat_reserve6	_bit_6		//---активность сигнала ножниц
#define _mb2_stat_reserve7	_bit_7		//---позиция ножниц НИЗ
#define _mb2_stat_reserve8	_bit_8		//---позиция ножниц ВЕРХ
#define _mb2_stat_reserve9	_bit_9		//---активность привода протяжки
#define _mb2_stat_reserve9_1	_bit_10		//---активность привода намотки
#define _mb2_stat_reserve9_2	_bit_11		//---протяжка завершена
#define _mb2_stat_reserve10	_bit_12		//---намотка завершена
#define _mb2_stat_reserve10_1	_bit_13		//---кусок отрезан
#define _mb2_stat_reserve10_2	_bit_14		//---режим протяжки
#define _mb2_stat_reserve10_3	_bit_15		//---режим намотки
#define _mb2_stat_reserve11	_bit_16		//---состояние останова
#define	_mb2_stat_reserve12	_bit_17		//---coстояние работы
#define _mb2_stat_reserve13	_bit_18		//---активность рабочего цикла
#define _mb2_stat_reserve14	_bit_19		//---рабочий кикл завершен
#define _mb2_stat_reserve15	_bit_20		//---кнопка пуск
#define _mb2_stat_reserve16	_bit_21		//---кнопка стоп
#define _mb2_stat_cutdbg	_bit_22		//отладка ножниц
#define _mb2_stat_reserve18	_bit_23
#define _mb2_stat_reserve19	_bit_24
#define _mb2_stat_errconn	_bit_25		//ошибка связи
#define _mb2_stat_reserve21	_bit_26		//---ошибка ножниц
#define _mb2_stat_reserve20	_bit_27		//---ошибка кнопок
#define _mb2_stat_reserve21_1	_bit_28		//---ошибка привода протяжки
#define _mb2_stat_reserve22	_bit_29		//---ошибка привода намотки
#define _mb2_stat_errparam	_bit_30		//ошибка параметров
#define _mb2_stat_error		_bit_31		//ошибка или авария
	U32	stat;
	U16	mk110_WrOutmaskSet;		//маска установки выходов
	U16	mk110_WrOutmaskClr;		//маска сброса выходов
	U16	SetCntCut;			//заданное количество	
} MODBUS2_SERVER;


//структура для Modbus 3 - для клиента
typedef struct _MODBUS3_CLIENT
{
	float	SetLenght;			//задание длины
	float	SetLenghtDeltaStart;		//заданная длина после старта - регулировка
	float	SetLenghtDeltaStop;		//заданная длина до стопа - регулировка		
	float	SetLenghtMin;			//минимальная заданная длина
	float	SetLenghtMax;			//максимальная заданная длина
	float	Lenght;				//измеренная длина
	float	pr_speed_m1;			//задание протяжки
	float	pr_speed_m1_min;		//минимальное задание протяжки
	float	pr_speed_m1_max;		//максимальное задание протяжки
	float	StepSpeedLenghtUp;		//шаг приращения при ускорении
	float	StepSpeedLenghtWown;		//шаг убавления при торможении
	float	ErrSetLenghtM1;
	U32	id;
#define _mb3_mode_conn_mk110	_bit_0		//есть связь с устройством ввода-вывода
#define _mb3_mode_conn_si30	_bit_1		//есть связь со счётчиком 
#define _mb3_mode_conn_mv110	_bit_2		//есть связь с устройством аналогового ввода
#define _mb3_mode_reserve1	_bit_3		//---есть связь с приводом протяжки
#define _mb3_mode_conn_m2	_bit_4		//есть связь с приводом намотки
#define _mb3_mode_conn_ip320	_bit_5		//есть связь с панелью ИП320
#define _mb3_mode_cut_out	_bit_6		//активность сигнала ножниц
#define _mb3_mode_cut_down	_bit_7		//позиция ножниц НИЗ - не отрез
#define _mb3_mode_cut_up	_bit_8		//позиция ножниц ВЕРХ - отрез
#define _mb3_mode_reserve2	_bit_9		//---активность привода протяжки
#define _mb3_mode_reserve3	_bit_10		//---активность привода намотки
#define _mb3_mode_m1end		_bit_11		//---протяжка завершена
#define _mb3_mofe_m2end		_bit_12		//---намотка завершена
#define _mb3_mode_cutend	_bit_13		//кусок отрезан
#define _mb3_mode_mode_m1	_bit_14		//режим протяжки
#define _mb3_mode_mode_m2	_bit_15		//режим намотки
#define _mb3_mode_stop		_bit_16		//режим останова
#define	_mb3_mode_work		_bit_17		//режим работы
#define _mb3_mode_work_loop	_bit_18		//активность рабочего цикла
#define _mb3_mode_work_loop_end	_bit_19		//рабочий кикл завершен
#define _mb3_mode_keyon		_bit_20		//кнопка пуск
#define _mb3_mode_keyoff	_bit_21		//кнопка стоп
#define _mb3_mode_cutdbg	_bit_22		//отладка ножниц
#define _mb3_mode_reserve7	_bit_23
#define _mb3_mode_reserve8	_bit_24
#define _mb3_mode_errconn	_bit_25		//ошибка связи
#define _mb3_mode_errcut	_bit_26		//ошибка ножниц
#define _mb3_mode_keyerr	_bit_27		//ошибка кнопок
#define _mb3_mode_reserve10	_bit_28		//---ошибка привода протяжки
#define _mb3_mode_err_m2	_bit_29		//ошибка привода намотки
#define _mb3_mode_errparam	_bit_30		//ошибка параметров
#define _mb3_mode_error		_bit_31		//ошибка или авария
	U32	mode;				//числовой идентификатор режима работы	
} MODBUS3_CLIENT;

//структура для Modbus 3 - для сервера
typedef struct _MODBUS3_SERVER
{
	U32	id;
#define _mb3_stat_reserve1	_bit_0		//---есть связь с устройством ввода-вывода
#define _mb3_stat_reserve2	_bit_1		//---есть связь со счётчиком 
#define _mb3_stat_reserve3	_bit_2		//---есть связь с устройством аналогового ввода
#define _mb3_stat_conn_m1	_bit_3		//есть связь с приводом протяжки
#define _mb3_stat_reserve4	_bit_4		//---есть связь с приводом намотки
#define _mb3_stat_reserve5	_bit_5		//---есть связь с панелью ИП320
#define _mb3_stat_reserve6	_bit_6		//---активность сигнала ножниц
#define _mb3_stat_reserve7	_bit_7		//---позиция ножниц НИЗ
#define _mb3_stat_reserve8	_bit_8		//---позиция ножниц ВЕРХ
#define _mb3_stat_m1_active	_bit_9		//активность привода протяжки
#define _mb3_stat_reserve9	_bit_10		//---активность привода намотки
#define _mb3_stat_m1end		_bit_11		//протяжка завершена
#define _mb3_stat_reserve10	_bit_12		//---намотка завершена
#define _mb3_stat_cutend	_bit_13		//---кусок отрезан
#define _mb3_stat_mode_m1	_bit_14		//режим протяжки
#define _mb3_stat_mode_m2	_bit_15		//режим намотки
#define _mb3_stat_reserve11	_bit_16		//---состояние останова
#define	_mb3_stat_reserve12	_bit_17		//---coстояние работы
#define _mb3_stat_reserve13	_bit_18		//---активность рабочего цикла
#define _mb3_stat_reserve14	_bit_19		//---рабочий кикл завершен
#define _mb3_stat_reserve15	_bit_20		//---кнопка пуск
#define _mb3_stat_reserve16	_bit_21		//---кнопка стоп
#define _mb3_stat_reserve17	_bit_22		//---отладка ножниц
#define _mb3_stat_conn_m3	_bit_23		//есь связь с приводом размотки
#define _mb3_stat_err_m3	_bit_24		//ошибка привода размотки
#define _mb3_stat_errconn	_bit_25		//ошибка связи
#define _mb3_stat_reserve21	_bit_26		//---ошибка ножниц
#define _mb3_stat_reserve212	_bit_27		//---ошибка кнопок
#define _mb3_stat_err_m1	_bit_28		//ошибка привода протяжки
#define _mb3_stat_reserve22	_bit_29		//---ошибка привода намотки
#define _mb3_stat_errparam	_bit_30		//ошибка параметров
#define _mb3_stat_error		_bit_31		//ошибка или авария
	U32	stat;				//состояние
} MODBUS3_SERVER;

//структура для Modbus 4 - для клиента
typedef struct _MODBUS4_CLIENT
{
	float	SetLenght;			//задание длины
	float	SetLenghtDeltaStart;		//заданная длина после старта - регулировка
	float	SetLenghtDeltaStop;		//заданная длина до стопа - регулировка		
	float	SetLenghtMin;			//минимальная заданная длина
	float	SetLenghtMax;			//максимальная заданная длина
	float	Lenght;				//измеренная длина
	float	pr_speed_m2;			//задание намотки
	float	pr_speed_m2_min;		//минимальное задание намотки
	float	pr_speed_m2_max;		//максимальное задание намотки
	float	StepSpeedLenghtUp;		//шаг приращения при ускорении намотки
	float	StepSpeedLenghtWown;		//шаг убавления при торможении намотки
	float	ErrSetLenghtM2;
	U32	id;
#define _mb4_mode_conn_mk110	_bit_0		//есть связь с устройством ввода-вывода
#define _mb4_mode_conn_si30	_bit_1		//есть связь со счётчиком 
#define _mb4_mode_conn_mv110	_bit_2		//есть связь с устройством аналогового ввода
#define _mb4_mode_reserve1	_bit_3		//---есть связь с приводом протяжки
#define _mb4_mode_conn_m2	_bit_4		//есть связь с приводом намотки
#define _mb4_mode_conn_ip320	_bit_5		//есть связь с панелью ИП320
#define _mb4_mode_cut_out	_bit_6		//активность сигнала ножниц
#define _mb4_mode_cut_down	_bit_7		//позиция ножниц НИЗ - не отрез
#define _mb4_mode_cut_up	_bit_8		//позиция ножниц ВЕРХ - отрез
#define _mb4_mode_reserve2	_bit_9		//---активность привода протяжки
#define _mb4_mode_reserve3	_bit_10		//---активность привода намотки
#define _mb4_mode_m1end		_bit_11		//---протяжка завершена
#define _mb4_mofe_m2end		_bit_12		//---намотка завершена
#define _mb4_mode_cutend	_bit_13		//кусок отрезан
#define _mb4_mode_mode_m1	_bit_14		//режим протяжки
#define _mb4_mode_mode_m2	_bit_15		//режим намотки
#define _mb4_mode_stop		_bit_16		//режим останова
#define	_mb4_mode_work		_bit_17		//режим работы
#define _mb4_mode_work_loop	_bit_18		//активность рабочего цикла
#define _mb4_mode_work_loop_end	_bit_19		//рабочий кикл завершен
#define _mb4_mode_keyon		_bit_20		//кнопка пуск
#define _mb4_mode_keyoff	_bit_21		//кнопка стоп
#define _mb4_mode_reserve6	_bit_22		//---отладка ножниц
#define _mb4_mode_reserve7	_bit_23
#define _mb4_mode_reserve8	_bit_24
#define _mb4_mode_errconn	_bit_25		//ошибка связи
#define _mb4_mode_errcut	_bit_26		//ошибка ножниц
#define _mb4_mode_keyerr	_bit_27		//ошибка кнопок
#define _mb4_mode_err_m1	_bit_28		//ошибка привода протяжки
#define _mb4_mode_reserve10	_bit_29		//---ошибка привода намотки
#define _mb4_mode_errparam	_bit_30		//ошибка параметров
#define _mb4_mode_error		_bit_31		//ошибка или авария
	U32	mode;				//числовой идентификатор режима работы	
} MODBUS4_CLIENT;


//структура для Modbus 4 - для сервера
typedef struct _MODBUS4_SERVER
{
	U32	id;
#define _mb4_stat_reserve1	_bit_0		//---есть связь с устройством ввода-вывода
#define _mb4_stat_reserve2	_bit_1		//---есть связь со счётчиком 
#define _mb4_stat_reserve3	_bit_2		//---есть связь с устройством аналогового ввода
#define _mb4_stat_reserve4	_bit_3		//---есть связь с приводом протяжки
#define _mb4_stat_conn_m2	_bit_4		//есть связь с приводом намотки
#define _mb4_stat_reserve5	_bit_5		//---есть связь с панелью ИП320
#define _mb4_stat_reserve6	_bit_6		//---активность сигнала ножниц
#define _mb4_stat_reserve7	_bit_7		//---позиция ножниц НИЗ
#define _mb4_stat_reserve8	_bit_8		//---позиция ножниц ВЕРХ
#define _mb4_stat_reserve9	_bit_9		//---активность привода протяжки
#define _mb4_stat_m2_active	_bit_10		//активность привода намотки
#define _mb4_stat_reserve10	_bit_11		//---протяжка завершена
#define _mb4_stat_m2end		_bit_12		//намотка завершена
#define _mb4_stat_cutend	_bit_13		//---кусок отрезан
#define _mb4_stat_mode_m1	_bit_14		//режим протяжки
#define _mb4_stat_mode_m2	_bit_15		//режим намотки
#define _mb4_stat_reserve11	_bit_16		//---состояние останова
#define	_mb4_stat_reserve12	_bit_17		//---coстояние работы
#define _mb4_stat_reserve13	_bit_18		//---активность рабочего цикла
#define _mb4_stat_reserve14	_bit_19		//---рабочий кикл завершен
#define _mb4_stat_reserve15	_bit_20		//---кнопка пуск
#define _mb4_stat_reserve16	_bit_21		//---кнопка стоп
#define _mb4_stat_reserve17	_bit_22		//---отладка ножниц
#define _mb4_stat_reserve18	_bit_23
#define _mb4_stat_reserve19	_bit_24
#define _mb4_stat_errconn	_bit_25		//ошибка связи
#define _mb4_stat_reserve21	_bit_26		//---ошибка ножниц
#define _mb4_stat_reserve212	_bit_27		//---ошибка кнопок
#define _mb4_stat_reserve22	_bit_28		//---ошибка привода протяжки
#define _mb4_stat_err_m2	_bit_29		//ошибка привода намотки
#define _mb4_stat_errparam	_bit_30		//ошибка параметров
#define _mb4_stat_error		_bit_31		//ошибка или авария
	U32	stat;				//состояние
} MODBUS4_SERVER;

//------------------------------------------------------------------------

//
typedef struct _WORK
{
	U8	id;					//числовой идентификатор записи
	//
	MODBUS1_SERVER	mb1s;				//параметры modbus1 для сервера
	MODBUS1_CLIENT	mb1c;				//параметры modbus1 для клиента
	MODBUS2_SERVER	mb2s;				//параметры modbus2 для сервера
	MODBUS2_CLIENT	mb2c;				//параметры modbus2 для клиента
	MODBUS3_SERVER	mb3s;				//параметры modbus3 для сервера
	MODBUS3_CLIENT	mb3c;				//параметры modbus3 для клиента
	MODBUS4_SERVER	mb4s;				//параметры modbus4 для сервера
	MODBUS4_CLIENT	mb4c;				//параметры modbus4 для клиента
	//
	float		SetLenghtDeltaStart_m1;
	float		SetLenghtDeltaStop_m1;
	float		pr_speed_m1_min;		//минимальное задание протяжки
	float		pr_speed_m1_max;		//максимальное задание протяжки
	float		StepSpeedLenghtUp_m1;		//шаг приращения при ускорении протяжки
	float		StepSpeedLenghtWown_m1;		//шаг убавления при торможении протяжки
	//
	float		SetLenghtDeltaStart_m2;
	float		SetLenghtDeltaStop_m2;
	float		pr_speed_m2_min;		//минимальное задание намотки
	float		pr_speed_m2_max;		//максимальное задание намотки
	float		StepSpeedLenghtUp_m2;		//шаг приращения при ускорении намотки
	float		StepSpeedLenghtWown_m2;		//шаг убавления при торможении намотки
	float		SI_30_correct;			//коррекция (множитель) счётчика СИ30
	//
} WORK;

extern WORK work;

extern pthread_mutex_t         MainMutex;
//вызываемая функция анализа и 
//обработки запросов по сокетам
//inline int	mwork(U8 * rbuf, U8 * sbuf);



#endif

